#
# This is the OpenShift ovn overlay network image.
# it provides an overlay network using ovs/ovn/ovn-kube
#
# The standard name for this image is ovn-kube

# Notes:
# This is for a build where the ovn-kubernetes utilities
# are built in this Dockerfile and included in the image (instead of the rpm)
#

FROM openshift/golang-builder:1.13 AS builder
ENV __doozer=update BUILD_RELEASE=202010301137.p0 BUILD_VERSION=v4.4.0 OS_GIT_MAJOR=4 OS_GIT_MINOR=4 OS_GIT_PATCH=0 OS_GIT_TREE_STATE=clean OS_GIT_VERSION=4.4.0-202010301137.p0 SOURCE_GIT_TREE_STATE=clean 
ENV __doozer=merge OS_GIT_COMMIT=13fb59a OS_GIT_VERSION=4.4.0-202010301137.p0-13fb59a SOURCE_DATE_EPOCH=1600898851 SOURCE_GIT_COMMIT=13fb59a8f043d1018023cf1c08bb5fbad8b6ccbc SOURCE_GIT_TAG=v0.3.11-1428-g13fb59a8 SOURCE_GIT_URL=https://github.com/openshift/ovn-kubernetes 

WORKDIR /go/src/github.com/openshift/ovn-kubernetes
COPY . .

# build the binaries
RUN cd go-controller; CGO_ENABLED=0 make
RUN cd go-controller; CGO_ENABLED=0 make windows

FROM openshift/ose-cli:v4.4.0.20201030.120944 AS cli
ENV __doozer=update BUILD_RELEASE=202010301137.p0 BUILD_VERSION=v4.4.0 OS_GIT_MAJOR=4 OS_GIT_MINOR=4 OS_GIT_PATCH=0 OS_GIT_TREE_STATE=clean OS_GIT_VERSION=4.4.0-202010301137.p0 SOURCE_GIT_TREE_STATE=clean 
ENV __doozer=merge OS_GIT_COMMIT=13fb59a OS_GIT_VERSION=4.4.0-202010301137.p0-13fb59a SOURCE_DATE_EPOCH=1600898851 SOURCE_GIT_COMMIT=13fb59a8f043d1018023cf1c08bb5fbad8b6ccbc SOURCE_GIT_TAG=v0.3.11-1428-g13fb59a8 SOURCE_GIT_URL=https://github.com/openshift/ovn-kubernetes 

FROM openshift/ose-base:v4.4.0.20201030.120944
ENV __doozer=update BUILD_RELEASE=202010301137.p0 BUILD_VERSION=v4.4.0 OS_GIT_MAJOR=4 OS_GIT_MINOR=4 OS_GIT_PATCH=0 OS_GIT_TREE_STATE=clean OS_GIT_VERSION=4.4.0-202010301137.p0 SOURCE_GIT_TREE_STATE=clean 
ENV __doozer=merge OS_GIT_COMMIT=13fb59a OS_GIT_VERSION=4.4.0-202010301137.p0-13fb59a SOURCE_DATE_EPOCH=1600898851 SOURCE_GIT_COMMIT=13fb59a8f043d1018023cf1c08bb5fbad8b6ccbc SOURCE_GIT_TAG=v0.3.11-1428-g13fb59a8 SOURCE_GIT_URL=https://github.com/openshift/ovn-kubernetes 

USER root

ENV PYTHONDONTWRITEBYTECODE yes

# install needed rpms - openvswitch must be 2.10.4 or higher
# install selinux-policy first to avoid a race
RUN yum install -y  \
	selinux-policy && \
	yum clean all

RUN INSTALL_PKGS=" \
	PyYAML openssl firewalld-filesystem \
	libpcap iproute strace \
	containernetworking-plugins yum-utils \
	tcpdump \
	" && \
	yum install -y --setopt=tsflags=nodocs --setopt=skip_missing_names_on_install=False $INSTALL_PKGS && \
	yum install -y --setopt=tsflags=nodocs --setopt=skip_missing_names_on_install=False "openvswitch2.13 >= 2.13.0-29.el7fdp" openvswitch2.13-devel && \
	#======== 4.4.24 Version ========
	# ovn2.13-20.06.2-4.el7fdp.x86_64
        # Pin to that
	yum install -y --setopt=tsflags=nodocs --setopt=skip_missing_names_on_install=False "ovn2.13 == 20.06.2-4.el7fdp" "ovn2.13-central == 20.06.2-4.el7fdp" "ovn2.13-host == 20.06.2-4.el7fdp" "ovn2.13-vtep == 20.06.2-4.el7fdp" && \
	yum clean all && rm -rf /var/cache/*

RUN mkdir -p /var/run/openvswitch && \
    mkdir -p /var/run/ovn && \
    mkdir -p /etc/cni/net.d && \
    mkdir -p /opt/cni/bin && \
    mkdir -p /usr/libexec/cni/ && \
    mkdir -p /root/windows/

COPY --from=builder /go/src/github.com/openshift/ovn-kubernetes/go-controller/_output/go/bin/ovnkube /usr/bin/
COPY --from=builder /go/src/github.com/openshift/ovn-kubernetes/go-controller/_output/go/bin/ovn-kube-util /usr/bin/
COPY --from=builder /go/src/github.com/openshift/ovn-kubernetes/go-controller/_output/go/bin/ovn-k8s-cni-overlay /usr/libexec/cni/
COPY --from=builder /go/src/github.com/openshift/ovn-kubernetes/go-controller/_output/go/bin/windows/hybrid-overlay-node.exe /root/windows/

COPY --from=cli /usr/bin/oc /usr/bin/
RUN ln -s /usr/bin/oc /usr/bin/kubectl
RUN stat /usr/bin/oc

# copy git commit number into image
COPY .git/HEAD /root/.git/HEAD
COPY .git/refs/heads/ /root/.git/refs/heads/

# ovnkube.sh is the entry point. This script examines environment
# variables to direct operation and configure ovn
COPY dist/images/ovnkube.sh /root/

# iptables wrappers
COPY ./dist/images/iptables-scripts/iptables /usr/sbin/
COPY ./dist/images/iptables-scripts/iptables-save /usr/sbin/
COPY ./dist/images/iptables-scripts/iptables-restore /usr/sbin/
COPY ./dist/images/iptables-scripts/ip6tables /usr/sbin/
COPY ./dist/images/iptables-scripts/ip6tables-save /usr/sbin/
COPY ./dist/images/iptables-scripts/ip6tables-restore /usr/sbin/
COPY ./dist/images/iptables-scripts/iptables /usr/sbin/


WORKDIR /root
ENTRYPOINT /root/ovnkube.sh

LABEL \
        io.k8s.display-name="ovn kubernetes" \
        io.k8s.description="This is a component of OpenShift Container Platform that provides an overlay network using ovn." \
        summary="This is a component of OpenShift Container Platform that provides an overlay network using ovn." \
        io.openshift.tags="openshift" \
        maintainer="Phil Cameron <pcameron@redhat.com>" \
        License="GPLv2+" \
        vendor="Red Hat" \
        name="openshift/ose-ovn-kubernetes" \
        com.redhat.component="ose-ovn-kubernetes-container" \
        io.openshift.maintainer.product="OpenShift Container Platform" \
        io.openshift.maintainer.component="Networking" \
        io.openshift.maintainer.subcomponent="ovn-kubernetes" \
        release="202010301137.p0" \
        io.openshift.build.commit.id="13fb59a8f043d1018023cf1c08bb5fbad8b6ccbc" \
        io.openshift.build.source-location="https://github.com/openshift/ovn-kubernetes" \
        io.openshift.build.commit.url="https://github.com/openshift/ovn-kubernetes/commit/13fb59a8f043d1018023cf1c08bb5fbad8b6ccbc" \
        version="v4.4.0"

